#!/usr/bin/perl 


	# restore.pl typed even more carefully than backup.pl bay rcoplen@corespace.com
	# messy code follows
	# This script will take an archive made by backup.pl and import it into a server running
	# EasySCP
	#
	#
	# Version: NAN
	#
	#
	#

use diagnostics;
use strict;
use warnings;
#no warnings qw(once);
use Cwd;
use Getopt::Long;
use Storable;
# Some paths, requirements, modules to make things easier and a few global vars
use FindBin;
use Data::Dumper qw(Dumper);
use lib "$FindBin::Bin/..";
use lib "/var/www/easyscp/engine/";
require 'easyscp_common_code.pl';

my $total_config = [];
#my $total_config = \%total_config;


# Arg processing

my $verbose = '';
my $domain = '';
my $dry_run = '';
my $ip = '';
my $ip_id = '';
GetOptions ('verbose' => \$verbose, 'dry_run' => \$dry_run ,'ip=f{1}' => \$ip );

if ( $verbose ) {
        print "Verbose Mode ON \n" ;

        };

if ( $dry_run) {
        print "Dry Run Mode ON \n";
        print "We're not going to do much but dump some output. \n \n";

        };

if ( !defined $ARGV[0]  ) {
        print "Usage: \n";
        print "$0 [OPTIONS] <domain name> \n";
        print "Avaliable options: \n";
        print " --verbose \n";
        print " --dry_run \n";
	print " --ip=<ip to assign domain to> (default: first ip in the db)\n";
        exit 1 ;
        } else {
         $domain=$ARGV[0];
}

# More global vars
my $cwd = getcwd();
my $backup_dir = $cwd."/archive" ;
my $dmn_backup_dir = $backup_dir."/".$domain ;
#my $zip = $main::cfg{'ZIP'};
my $zip = 'zip';
my $backup_filename = "$domain.tar.gz";
my $cmd_tar = $main::cfg{'CMD_TAR'};
my $cmd_rm = $main::cfg{'CMD_RM'};
my $cmd_mv = $main::cfg{'CMD_MV'};
my $dmn_dir = $main::cfg{'APACHE_WWW_DIR'}."/$domain";
my $mail_dir = $main::cfg{'MTA_VIRTUAL_MAIL_DIR'};
my $unpack_cmd = "$cmd_tar --extract --gzip --file=$backup_dir/$backup_filename -C $backup_dir " ;
my $unpack_web_cmd = "$cmd_tar --extract --gzip --file=$backup_dir/$domain/$domain-www.tar.gz -C $main::cfg{'APACHE_WWW_DIR'} " ;
my $unpack_mail_cmd = "$cmd_tar --extract --gzip --file=$backup_dir/$domain/$domain-mail.tar.gz -C $main::cfg{'MTA_VIRTUAL_MAIL_DIR'} " ;
my $result = '';
my $dmn_config_file = $dmn_backup_dir."/config.ser";
my %reseller_id = ();
my $domain_admin_id = '';
my $domain_id = '';
my %domain_user_info = ();



# We need to run the request manager after we add things to the DB. 
sub run_rqst_mgr {
		system ('/etc/init.d/easyscp_daemon stop');
		system ('/var/www/easyscp/engine/easyscp-rqst-mngr');
		system ('/etc/init.d/easyscp_daemon start');
}

# Does what it says it does, unpacks the archive. 
sub unpack_archive {
	my $archive_file="$backup_dir/$backup_filename";
	if ( -f  $archive_file ) {

		print "Found backup archive $backup_dir/$backup_filename, unzipping it.\n";
		if ( ( ! $dry_run ) &&  (length($unpack_cmd) != 0 )) {
#		if (  (length($unpack_cmd) != 0 )) {
			
			$result = sys_command($unpack_cmd);
		}
		
	} else {
		print "Cannot find backup archive $backup_dir/$backup_filename, exiting. \n";
	exit 1; 
	}
}

# Reads the config out of the file in the archive
sub read_config {
	
	if ( -f $dmn_config_file ) {
	
		$total_config = retrieve( $dmn_config_file ) ;
	
	return ($total_config);
	} else {
		print "cannot find $dmn_config_file, exiting";
		exit 1;
	}
}

# Gets the ID of the IP address specified on the command line, if any. 

sub get_ip_id {

	my $ip_id = '';
	my $sql_query="SELECT `ip_id` FROM `server_ips` WHERE `ip_number`='$ip'";
	
        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $ip_id = $main::db->do("SET NAMES 'utf8';");
                 }
        }

	$ip_id = $main::db->selectrow_hashref($sql_query);
	if ($verbose) {
		print "ip_id is: \n";
		print Dumper \$ip_id;
	}
	return($ip_id);
}


# Grabs the ID of the first IP address in the DB if none was specified on the command line
sub get_default_ip_id {
	my  $ip_id = '';
	my  $sql_query = "SELECT `ip_id` FROM `server_ips` ORDER BY `ip_id` LIMIT 0, 1";
	
        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $ip_id = $main::db->do("SET NAMES 'utf8';");
                 }
        }

        $ip_id = $main::db->selectrow_hashref($sql_query);
        if ($verbose) {
                print "default ip_id is: \n";
                print Dumper \$ip_id;
        }
        return($ip_id);
}

# Our version of this always grabs the first resller in the DB

sub get_reseller { 

	my $reseller_result = '';
	my $sql_query = "SELECT `admin_id` FROM `admin` WHERE `admin_type` = 'reseller' ORDER BY `admin_id` LIMIT 0, 1";
	if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $reseller_result = $main::db->do("SET NAMES 'utf8';");
                 }
        }

	$reseller_result = $main::db->selectrow_hashref($sql_query);
	print Dumper \$reseller_result;
	if (defined $reseller_result) {
		%reseller_id=%$reseller_result;
		if ($verbose) {
			print "reseller_id: \n";
			print Dumper \%reseller_id;
		}	
	} else {
		print "Unable to find a reseller to add the domain under.\n";
		print "Please make sure you've set up a reseller before\n";
		print "adding domains. Exiting. \n";
		exit 1;
	}

}

# We unpack the archive here and set these variables because the subs below depend on the vars being set. 

unpack_archive(); 
$total_config = read_config();
my %total_config = %$total_config;



# Actually creates the domain user and the domain in the DB, calls the request manager above to add them to the config, and populates the system GID and UID of the domain for us to use later. 	
sub create_domain {
	my $domain_admin_create_sql = '';
	my $domain_id_hashref = '';
	my $domain_creation_sql = '';
	my $domain_user_sql = '';
	my $sql_query = "INSERT INTO `admin`  ( `admin_name`, `admin_pass`, `admin_type`, `domain_created`, `customer_id`, `created_by`, `fname`, `lname`, `gender`, `firm`, `zip`, `city`, `state`, `country`, `email`, `phone`, `fax`, `street1`, `street2` )  VALUES ( '$total_config{'domain'}{'admin_name'}','$total_config{'domain'}{'admin_pass'}','$total_config{'domain'}{'admin_type'}','0','','".$reseller_id{'admin_id'}."','$total_config{'domain'}{'fname'}','$total_config{'domain'}{'lname'}','$total_config{'domain'}{'gender'}','$total_config{'domain'}{'firm'}','$total_config{'domain'}{'zip'}','$total_config{'domain'}{'city'}','$total_config{'domain'}{'state'}','$total_config{'domain'}{'country'}','$total_config{'domain'}{'email'}','$total_config{'domain'}{'phone'}','$total_config{'domain'}{'fax'}','$total_config{'domain'}{'street1'}','$total_config{'domain'}{'street2'}')";

	my $domain_admin_id_query = "SELECT `admin_id` from `admin` where `admin_name` = '$domain'";


	if ( $verbose ) {
		print "$sql_query \n";
	}


        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $domain_admin_create_sql = $main::db->do("SET NAMES 'utf8';");
                 }
        }
        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $domain_admin_id_query = $main::db->do("SET NAMES 'utf8';");
                 }
        }

	if (! $dry_run) {
		$domain_admin_create_sql = $main::db->do($sql_query) ; 
		$domain_id_hashref = $main::db->selectrow_hashref($domain_admin_id_query);
		$domain_admin_id=$domain_id_hashref->{'admin_id'};
#		$domain_id=$domain_id_hashref->{'domain_id'};
		if ($verbose) {

		print Dumper \$domain_id_hashref ;

		}
		
	} else {
		$domain_admin_id = '666';
	}
	my $domain_creation_query = "INSERT INTO `domain`".
                        " (`domain_name`, `domain_created`, `domain_expires`, `domain_mailacc_limit`, `domain_ftpacc_limit`, ".
                        "  `domain_traffic_limit`, `domain_sqld_limit`, `domain_sqlu_limit`, `domain_alias_limit`, ".
                        "  `domain_subd_limit`, `domain_disk_limit`, `domain_php`, `domain_cgi`, `domain_dns`, `allowbackup`, ".
                        "  `domain_status`, `domain_created_id`, `domain_admin_id`, `domain_ip_id`)".
                        " VALUES".
			"('$total_config{'domain'}{'admin_name'}','0','$total_config{'domain'}{'domain_expires'}','$total_config{'domain'}{'domain_mailacc_limit'}','$total_config{'domain'}{'domain_ftpacc_limit'}',".
			"'$total_config{'domain'}{'domain_traffic_limit'}','$total_config{'domain'}{'domain_sqld_limit'}','$total_config{'domain'}{'domain_sqlu_limit'}','$total_config{'domain'}{'domain_alias_limit'}','$total_config{'domain'}{'domain_subd_limit'}',".
			"'$total_config{'domain'}{'domain_disk_limit'}','$total_config{'domain'}{'domain_php'}','$total_config{'domain'}{'domain_cgi'}','$total_config{'domain'}{'domain_dns'}',". 
			"'$total_config{'domain'}{'allowbackup'}','toadd','".$reseller_id{'admin_id'}."','$domain_admin_id','".$ip_id->{'ip_id'}."')";

	my $domain_uid_query = "SELECT `domain_id`, `domain_gid`, `domain_uid` FROM `domain` where `domain_admin_id` = '$domain_admin_id'";
        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $domain_creation_sql = $main::db->do("SET NAMES 'utf8';");
        	}
        }
        if (!defined $main::db || !ref $main::db) {
                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                if (!defined $main::db) {
                return (-1, '');
                # DB: use always UTF8
                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        $domain_user_sql = $main::db->do("SET NAMES 'utf8';");
        	}
        }

	if (! $dry_run ) {

			
		$domain_creation_sql = $main::db->do($domain_creation_query) ; 
		run_rqst_mgr();
		$domain_user_sql = $main::db->selectrow_hashref($domain_uid_query);
		%domain_user_info = %$domain_user_sql;
		
	} else {	
		%domain_user_info = ( 'domain_id', '666', 'domain_gid', 'vu666', 'domain_uid', 'vu666' );
	}

	if ($verbose) {

		print "$domain_creation_query \n";
		print "result of domain admin creation: \n";
		print Dumper \$domain_admin_create_sql;
		print "result of domain creation: \n";
		print Dumper \$domain_creation_sql;

		print "domain_admin_id: \n";
		print Dumper \$domain_admin_id;
		print "domain_user_info: \n";
		print Dumper \%domain_user_info;

	}
}


sub create_databases {
	my $create_db_result='';
	my $db_id = '';
        my $import_command = '';
	my $gunzip_db_command = "gunzip $dmn_backup_dir/*.sql.gz";
	my $sql_pass = $main::cfg{'DATABASE_PASSWORD'};
	system ($gunzip_db_command);
	foreach $db_id ( keys %{ $total_config{'databases'} } ) {
		my $sql_query="INSERT INTO `sql_database`  (`domain_id`, `sqld_name`)  VALUES  ( '$domain_user_info{'domain_id'}', '$total_config{'databases'}{$db_id}{'sqld_name'}')";
		my $create_db_query="CREATE DATABASE `$total_config{'databases'}{$db_id}{'sqld_name'}`";
		my $import_command = " mysql $total_config{'databases'}{$db_id}{'sqld_name'} < $dmn_backup_dir/$total_config{'databases'}{$db_id}{'sqld_name'}.sql";
       		if (!defined $main::db || !ref $main::db) {
	               	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                	if (!defined $main::db) {
                	return (-1, '');
                	# DB: use always UTF8
        	       	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	$create_db_result = $main::db->do("SET NAMES 'utf8';");
			}
		}
		if (!$dry_run) {
			$create_db_result = $main::db->do($sql_query);
			$create_db_result = $main::db->do($create_db_query);
			 system($import_command);
			
                }

		if ( $verbose ) {
			print "$sql_query\n";
			print "$create_db_query\n";
			print "$import_command\n";
		}
        }
}

sub create_database_users {

	my $create_user_result='';
	my $create_user_result2='';
	my $create_user_result3='';
	my $user_pass ='';
	my $user ='';
	my $database = '';
	my $db_id = '';
	my $db_id_result = [];
	my %db_association = ();
	foreach $database ( keys %{ $total_config{'databases'}}) {
		# find which db the user is associated with, and insert the users in EasySCP's db, and issue the necessary GRANTs. 		
		foreach $user ( keys %{ $total_config{'database_users'}{$database} } ) {
			my $sql_db_id_query = "SELECT `sqld_id` from `sql_database` where sqld_name = '$total_config{'databases'}{$database}{'sqld_name'}'";
	                if (!defined $main::db || !ref $main::db) {
        	                $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                	        if (!defined $main::db) {
                        	return (-1, '');
	                        # DB: use always UTF8
        	                } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                	                $db_id = $main::db->do("SET NAMES 'utf8';");
                        	}
                	}	
			if (!$dry_run) {
				 $db_id_result = $main::db->selectrow_arrayref($sql_db_id_query);
				 $db_id = $db_id_result->[0];
				if ($verbose) {
					print "\$sql_db_id_query is $sql_db_id_query\n";
					print Dumper \$db_id_result ;
				}
			}
			$user_pass = encrypt_db_password($total_config{'database_users'}{$database}{$user}{'sqlu_pass'});
			my $sql_query_localhost = "GRANT ALL PRIVILEGES ON `$total_config{'databases'}{$database}{'sqld_name'}`.* TO '$total_config{'database_users'}{$database}{$user}{'sqlu_name'}'\@'localhost' IDENTIFIED BY '$total_config{'database_users'}{$database}{$user}{'sqlu_pass'}'";
			my $sql_query_wildcard = "GRANT ALL PRIVILEGES ON `$total_config{'databases'}{$database}{'sqld_name'}`.* TO '$total_config{'database_users'}{$database}{$user}{'sqlu_name'}'\@'%' IDENTIFIED BY '$total_config{'database_users'}{$database}{$user}{'sqlu_pass'}'";
			my $sql_query_easyscp = "INSERT INTO `sql_user` (`sqld_id`, `sqlu_name`, `sqlu_pass`) VALUES ( '$db_id', '$total_config{'database_users'}{$database}{$user}{'sqlu_name'}', '$user_pass')";
				if ( $verbose )	{
					print " $sql_query_localhost \n";
					print " $sql_query_wildcard\n";
					print " $sql_query_easyscp\n";
				}
				if ( !$dry_run ) {
					$create_user_result = $main::db->do($sql_query_localhost);
					$create_user_result2 = $main::db->do($sql_query_wildcard);
					$create_user_result3 = $main::db->do($sql_query_easyscp);
				}
					
		}	
		
	}
}

sub get_subdomain_id { 
	my ($subdomain_id, $subdomain_index, $subdom_sql_query, $sub_id ) = ( undef, undef, undef, undef) ;
	foreach $subdomain_index ( keys %{ $total_config{'subdomain'}} ) {
		if ($_[0] == $total_config{'subdomain'}{$subdomain_index}{'subdomain_id'}) {
			$subdom_sql_query = "SELECT subdomain_id FROM subdomain WHERE subdomain_name = '$total_config{'subdomain'}{$subdomain_index}{'subdomain_name'}' AND domain_id='$domain_user_info{'domain_id'}'";

		}
	}
	
    	if (!defined $main::db || !ref $main::db) {
               	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
               	if (!defined $main::db) {
               	return (-1, '');
               	# DB: use always UTF8
       	       	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                       	$subdomain_id = $main::db->do("SET NAMES 'utf8';");
		}
	}
		$subdomain_id = $main::db->selectrow_array($subdom_sql_query);
	if ($verbose) {

		print "subdom sql id query is $subdom_sql_query\n";
		print "we're gonna return $subdomain_id\n";
	}
	return ($subdomain_id);

}

sub get_alias_id {
	my ( $alias_id, $alias_index, $alias_query, $sub_id, $sql_query ) = ( undef, undef, undef, undef, undef );
	foreach $alias_index (keys %{ $total_config{'aliasses'}}) {
		if ( $_[0] == $total_config{'aliasses'}{$alias_index}{'alias_id'} ) {
			 $sql_query = "SELECT alias_id FROM domain_aliasses WHERE alias_name ='$total_config{'aliasses'}{$alias_index}{'alias_name'}' AND domain_id='$domain_user_info{'domain_id'}'";
		}
	}
    	if (!defined $main::db || !ref $main::db) {
               	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
               	if (!defined $main::db) {
               	return (-1, '');
               	# DB: use always UTF8
       	       	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                       	$sql_query = $main::db->do("SET NAMES 'utf8';");
		}
	}
		$alias_id = $main::db->selectrow_array($sql_query);
	if ($verbose) {

		print "alias sql id query is $sql_query\n";
		print "we're gonna return $alias_id\n";
	}
	
	return ($alias_id);

}


sub get_subdomain_alias_id {

	my ( $subd_alias_id, $subd_alias_index, $subd_alias , $subd_id, $sql_query) = ( undef, undef, undef, undef, undef ); 
	foreach $subd_alias_index ( keys %{ $total_config{'subdomain_aliasses'}} ) {
SUBDOMLOOP:	foreach $subd_alias ( keys %{ $total_config{'subdomain_aliasses'}{$subd_alias_index}} ) {
			print Dumper \$total_config{'subdomain_aliasses'}{$subd_alias_index}{$subd_alias}{'subdomain_alias_name'};
			if ( $_[0] == $total_config{'subdomain_aliasses'}{$subd_alias_index}{$subd_alias}{'subdomain_alias_id'} ){
				$sql_query = "SELECT subdomain_alias_id FROM subdomain_alias WHERE subdomain_alias_name='$total_config{'subdomain_aliasses'}{$subd_alias_index}{$subd_alias}{'subdomain_alias_name'}'";
			} else { 
				next SUBDOMLOOP ;
				}
		if ($verbose) {
		print " arg is $_[0]\n";
		print " alias id is $total_config{'subdomain_aliasses'}{$subd_alias_index}{$subd_alias}{'subdomain_alias_id'}\n";
		}

			
		#}
    		if (!defined $main::db || !ref $main::db) {
               		$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
	               	if (!defined $main::db) {
        	       	return (-1, '');
               		# DB: use always UTF8
	       	       	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
        	               	$sql_query = $main::db->do("SET NAMES 'utf8';");
			}
		}
	
		$subd_alias_id = $main::db->selectrow_array($sql_query);
		}
	}
	if ($verbose) {

		print "subdom alias sql id query is $sql_query\n";
		print "we're gonna return $subd_alias_id-\n";
		print Dumper \$subd_alias_id;
	}
	
	return ($subd_alias_id);

	
}

sub create_email_users {

	my $create_user_result = '';
	my $user = '';
	my $sub_id = '';
	my $mail_pass = '';
	foreach $user (keys %{ $total_config{'email'} } ) { 
		if ( !defined  $total_config{'email'}{$user}{'mail_auto_respond_text'} ) {
				$total_config{'email'}{$user}{'mail_auto_respond_text'} = '_no_';
		}
		if ( $total_config{'email'}{$user}{'sub_id'} != 0 ) {
			if ( $total_config{'email'}{$user}{'mail_type'} eq 'subdom_mail' ) {
				#then it's a subdomain, get the id
				$sub_id = get_subdomain_id($total_config{'email'}{$user}{'sub_id'});
			} 
			if ( $total_config{'email'}{$user}{'mail_type'} eq 'alias_mail' ) {
				#then it's an alias, get the id
				$sub_id = get_alias_id($total_config{'email'}{$user}{'sub_id'});
			}
			if ( $total_config{'email'}{$user}{'mail_type'} eq 'alssub_mail' ) {
				# then it's the horribly named subdomain alias, get the id
				$sub_id = get_subdomain_alias_id($total_config{'email'}{$user}{'sub_id'}); 
			}
			if ( $total_config{'email'}{$user}{'mail_type'} eq 'alias_forward' ) {
				# then it's an alias forward of course, get the id
				$sub_id = get_alias_id($total_config{'email'}{$user}{'sub_id'}); 
			}

		
		} else { 
		
		$sub_id = '0';

		}


		if ($total_config{'email'}{$user}{'mail_pass'} eq "_no_") {
		
			$mail_pass = $total_config{'email'}{$user}{'mail_pass'};

		} else {

			$mail_pass = encrypt_db_password($total_config{'email'}{$user}{'mail_pass'});
		}



		my $sql_query = "INSERT INTO `mail_users` (`domain_id`, `mail_acc`, `mail_pass`, `mail_forward`, `mail_type`, `sub_id`, `status`,`mail_auto_respond`, `mail_auto_respond_text`, `quota`, `mail_addr`)".
				" VALUES  ( '$domain_user_info{'domain_id'}', '$total_config{'email'}{$user}{'mail_acc'}', '$mail_pass', '$total_config{'email'}{$user}{'mail_forward'}', '$total_config{'email'}{$user}{'mail_type'}', '$sub_id', 'toadd', '$total_config{'email'}{$user}{'mail_auto_respond'}', '$total_config{'email'}{$user}{'mail_auto_respond_text'}', '$total_config{'email'}{$user}{'quota'}', '$total_config{'email'}{$user}{'mail_addr'}')";
		if ($verbose) {
			print "$sql_query\n";
		}
       		if (!defined $main::db || !ref $main::db) {
	               	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                	if (!defined $main::db) {
                	return (-1, '');
                	# DB: use always UTF8
        	       	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	$create_user_result = $main::db->do("SET NAMES 'utf8';");
			}
		}
		if (!$dry_run) {
			$create_user_result = $main::db->do($sql_query);
		}
	}
}


sub create_subdomains {

	my $create_subdomain_result ='';
	my $subdomain_number ='';
	foreach $subdomain_number (keys %{ $total_config{'subdomain'} } ) {
		my $sql_query = "INSERT INTO `subdomain`  (`domain_id`, `subdomain_name`, `subdomain_mount`, `subdomain_url_forward`, `subdomain_status`) VALUES ('$domain_user_info{'domain_id'}', '$total_config{'subdomain'}{$subdomain_number}{'subdomain_name'}',  '$total_config{'subdomain'}{$subdomain_number}{'subdomain_mount'}', '$total_config{'subdomain'}{$subdomain_number}{'subdomain_url_forward'}', 'toadd')";
	
		if ($verbose) {
			print "$sql_query\n";
		}
       		if (!defined $main::db || !ref $main::db) {
	               	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                	if (!defined $main::db) {
                	return (-1, '');
                	# DB: use always UTF8
        	       	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	$create_subdomain_result = $main::db->do("SET NAMES 'utf8';");
			}
		}
		if (!$dry_run) {
			$create_subdomain_result = $main::db->do($sql_query);
			run_rqst_mgr();
		}
	}
}



sub create_domain_aliases {
		
	my $create_alias_result ='';
	my $alias_id = '';
	my $subdmn_alias_id = '';
	#create the alias entries
	foreach $alias_id ( keys %{ $total_config{'aliasses'} }) {
		my $sql_query = "INSERT INTO `domain_aliasses` (`domain_id`, `alias_name`, `alias_mount`, `alias_status`, `alias_ip_id`, `url_forward`)  VALUES ( '$domain_user_info{'domain_id'}', '$total_config{'aliasses'}{$alias_id}{'alias_name'}', '$total_config{'aliasses'}{$alias_id}{'alias_mount'}', 'toadd', '".$ip_id->{'ip_id'}."', '$total_config{'aliasses'}{$alias_id}{'url_forward'}' )";
		
		if ($verbose) {
			print "$sql_query\n";
		}
       		if (!defined $main::db || !ref $main::db) {
	               	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                	if (!defined $main::db) {
                	return (-1, '');
                	# DB: use always UTF8
        	       	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	$create_alias_result = $main::db->do("SET NAMES 'utf8';");
			}
		}
		if (!$dry_run) {
			$create_alias_result = $main::db->do($sql_query);
			run_rqst_mgr();
		}
	}
	
	#create the subdomain alias entries
	foreach $alias_id ( keys %{ $total_config{'subdomain_aliasses'}} ) {
		foreach $subdmn_alias_id ( keys %{ $total_config{'subdomain_aliasses'}{$alias_id} } ) {
		my $new_alias_id = get_alias_id($alias_id);
		my $sql_query = "INSERT INTO `subdomain_alias` (`alias_id`, `subdomain_alias_name`, `subdomain_alias_url_forward`, `subdomain_alias_status`, `subdomain_alias_mount`) VALUES ('$new_alias_id', '$total_config{'subdomain_aliasses'}{$alias_id}{$subdmn_alias_id}{'subdomain_alias_name'}', '$total_config{'subdomain_aliasses'}{$alias_id}{$subdmn_alias_id}{'subdomain_alias_url_forward'}', 'toadd', '$total_config{'subdomain_aliasses'}{$alias_id}{$subdmn_alias_id}{'subdomain_alias_mount'}')";
			if ($verbose) {
                        	print "$sql_query\n";
	                }
        	        if (!defined $main::db || !ref $main::db) {
                	        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                        	if (!defined $main::db) {
	                        return (-1, '');
        	                # DB: use always UTF8
                	        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	        $create_alias_result = $main::db->do("SET NAMES 'utf8';");
	                        }
        	        }
                	if (!$dry_run) {
                        	$create_alias_result = $main::db->do($sql_query);
				run_rqst_mgr();
	                }


		}
	}


}


sub create_web_users {
	
	my ( $web_user_result, $web_user_id, $sql_query ) = ( undef, undef, undef ); 
	foreach $web_user_id ( keys %{ $total_config{'web_user'}} ) {
		$sql_query = "INSERT INTO `htaccess_users` (`dmn_id`, `uname`, `upass`, `status`)  VALUES ('$domain_user_info{'domain_id'}', '$total_config{'web_user'}{$web_user_id}{'uname'}', '$total_config{'web_user'}{$web_user_id}{'upass'}', 'toadd' )";
		if ($verbose) {
                        	print "$sql_query\n";
	                }
        	        if (!defined $main::db || !ref $main::db) {
                	        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                        	if (!defined $main::db) {
	                        return (-1, '');
        	                # DB: use always UTF8
                	        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	        $web_user_result = $main::db->do("SET NAMES 'utf8';");
	                        }
        	        }
                	if (!$dry_run) {
                        	$web_user_result = $main::db->do($sql_query);
				run_rqst_mgr();
	        }
	}
}




sub create_web_groups {
	
	my ( $web_group_result, $web_group_id, $sql_query, $member_sql , $member, $new_user_ids, $new_user_ids_string ,  $old_user ) = ( undef, undef, undef, undef, undef, undef, undef, undef ) ;
	my @member_array=();
	my @new_member_array=();
	foreach $web_group_id ( keys %{ $total_config{'web_group'}} ) {
		@member_array = split(/,/,$total_config{'web_group'}{$web_group_id}{'members'});
		foreach $member (@member_array) {
			foreach $old_user ( keys $total_config{'web_user'} ) {
				$member_sql =  " SELECT id FROM htaccess_users WHERE dmn_id = '$domain_user_info{'domain_id'}' and uname = '$total_config{'web_user'}{$old_user}{'uname'}'";
				if ($old_user eq $member) {
					if ($verbose) {
                                               	print "$member_sql\n";
                                       	}
       	        			if (!defined $main::db || !ref $main::db) {
                	        		$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
	                        		if (!defined $main::db) {
			                        return (-1, '');
       				                # DB: use always UTF8
			  		        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                       				        $new_user_ids = $main::db->do("SET NAMES 'utf8';");
                        			}
	        	        	}
	        	        	if (!$dry_run) {
       		        	        	$new_user_ids = $main::db->selectrow_array($member_sql);
						push @new_member_array, $new_user_ids;
						
               				}
				}
				if (!$dry_run) {
					$new_user_ids_string = join (",", @new_member_array);      
					if ($verbose) {
					print "new user ids value is $new_user_ids\n";
					print Dumper \@new_member_array;
					}
				}
			 
			} 
		}
						
		$sql_query = "INSERT INTO `htaccess_groups` (`dmn_id`, `ugroup`, `members`, `status`) VALUES ('$domain_user_info{'domain_id'}', '$total_config{'web_group'}{$web_group_id}{'ugroup'}', '$new_user_ids_string', 'toadd')";
		if ($verbose) {
                        	print "$sql_query\n";
	                }
        	        if (!defined $main::db || !ref $main::db) {
                	        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                        	if (!defined $main::db) {
	                        return (-1, '');
        	                # DB: use always UTF8
                	        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	        $web_group_result = $main::db->do("SET NAMES 'utf8';");
	                        }
        	        }
                	if (!$dry_run) {
                        	$web_group_result = $main::db->do($sql_query);
				run_rqst_mgr();
                }
	}


}


sub create_web_access {
	
	my ( $web_access_result, $web_access_id, $old_group_id , $sql_query, $group_id_sql_query, $user_id_sql_query, $new_group_id, $group_name, $new_user_id, $old_id, $old_user, $new_user_id_string ) = ( undef, undef, undef, undef, undef, undef, undef, undef, undef, undef, undef, undef );
	my %new_group_hash = ();
	my %new_user_hash = ();
	my @user_array = ();
	foreach $web_access_id (keys %{ $total_config{'web_access'}} ) {
		foreach $old_group_id (keys %{ $total_config{'web_group'}}  ) { 
			if ( $total_config{'web_access'}{$web_access_id}{'group_id'} ne "0" ) {
				if ( $total_config{'web_group'}{$old_group_id}{'id'} eq  $total_config{'web_access'}{$web_access_id}{'group_id'} ) {
					$group_id_sql_query = " SELECT id FROM htaccess_groups WHERE dmn_id = '$domain_user_info{'domain_id'}' AND ugroup = '$total_config{'web_group'}{$old_group_id}{'ugroup'}'" ;
	
					if ($verbose) {
						print "\$group_id_sql_query $group_id_sql_query\n";
	        		        }
        	        		if (!defined $main::db || !ref $main::db) {
	                	        	$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
	                        		if (!defined $main::db) {
			                        return (-1, '');
        			                # DB: use always UTF8
                			        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        			        $new_group_id = $main::db->do("SET NAMES 'utf8';");
	                        		}
	        	        	}
	        	        	if (!$dry_run) {
        	        	        	$new_group_id = $main::db->selectrow_array($group_id_sql_query);
						
						if ($verbose) {
							print Dumper \$new_group_id;
						}
                			}	
				}
			} else {
			$new_group_id = '0';
			}

			if (  $total_config{'web_access'}{$web_access_id}{'user_id'} ne "0" ) {
				if (  $total_config{'web_group'}{$old_group_id}{'members'} eq $total_config{'web_access'}{$web_access_id}{'user_id'} ) {
					my @user_ids=split (/,/, $total_config{'web_access'}{$web_access_id}{'user_id'});

					if ($verbose) {
					print Dumper \@user_ids;
					}

					foreach $old_id (@user_ids) {
						foreach $old_user ( keys $total_config{'web_user'} ) {
							if ( $old_id eq $old_user ) {
								$user_id_sql_query = " SELECT id FROM htaccess_users WHERE dmn_id = '$domain_user_info{'domain_id'}' and uname = '$total_config{'web_user'}{$old_user}{'uname'}'";
					
								if ($verbose) {
	                                                	print "\$user_id_sql_query $user_id_sql_query\n";
        	                                		}
	       		        				if (!defined $main::db || !ref $main::db) {
	                		        			$main::db = DBI->connect(@main::db_connect, {PrintError => 0});
			                	        		if (!defined $main::db) {
					        	                return (-1, '');
        					        	        # DB: use always UTF8
                					        	} elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        					        	$new_user_id = $main::db->do("SET NAMES 'utf8';");
		                        				}
			        	        		}
			        	        		if (!$dry_run) {
        			        	        		$new_user_id = $main::db->selectrow_array($user_id_sql_query);
									push @user_array, $new_user_id;
									
                						}
							}
							if (!$dry_run) {
								$new_user_id_string = join (",", @user_array);      
								if ($verbose) {
								print "new user id value is $new_user_id\n";
								print Dumper \$new_user_id_string
								}
							}
						}
					} 
				}
			} else {
			$new_user_id_string = '0';
			}
			
		}
		$sql_query = "INSERT INTO `htaccess`  (`dmn_id`, `user_id`, `group_id`, `auth_type`, `auth_name`, `path`, `status`) VALUES  ( '$domain_user_info{'domain_id'}', '$new_user_id_string', '$new_group_id', '$total_config{'web_access'}{$web_access_id}{'auth_type'}', '$total_config{'web_access'}{$web_access_id}{'auth_name'}', '$total_config{'web_access'}{$web_access_id}{'path'}', 'toadd') ";
			if ($verbose) {
                        	print "$sql_query\n";
	                }
        	        if (!defined $main::db || !ref $main::db) {
                	        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                        	if (!defined $main::db) {
	                        return (-1, '');
        	                # DB: use always UTF8
                	        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                        	        $web_access_result = $main::db->do("SET NAMES 'utf8';");
	                        }
        	        }
                	if (!$dry_run) {
                        	$web_access_result = $main::db->do($sql_query);
				run_rqst_mgr();
                	}	
			
	}
	

}



sub create_ftp_accounts {
	
	my ( $user, $sql_query, $ftp_result, $ftp_users, $ftp_group_sql, $ftp_group_result ) = ( undef, undef, undef, undef, undef, undef );
	foreach $user (keys %{ $total_config{'ftp'}} ) {
		$sql_query = "INSERT INTO `ftp_users` (`userid`, `passwd`, `uid`, `gid`, `shell`, `homedir`) VALUES ( '$user', '$total_config{'ftp'}{$user}{'passwd'}', '$domain_user_info{'domain_uid'}', '$domain_user_info{'domain_gid'}', '/bin/bash', '$total_config{'ftp'}{$user}{'homedir'}' )";
		if ($verbose) {
                       	print "$sql_query\n";
                }
       	        if (!defined $main::db || !ref $main::db) {
               	        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                       	if (!defined $main::db) {
                        return (-1, '');
       	                # DB: use always UTF8
               	        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                       	        $ftp_result = $main::db->do("SET NAMES 'utf8';");
                        }
       	        }
               	if (!$dry_run) {
                       	$ftp_result = $main::db->do($sql_query);
			if (!defined $ftp_users) {
				$ftp_users = "$user";
			} else {
				$ftp_users = "$ftp_users,$user";
			}
               	}	
			
	}
	if (defined $ftp_users){
		$ftp_group_sql = "INSERT INTO `ftp_group` (`groupname`, `gid`, `members`) VALUES ( '$total_config{'domain'}{'domain_name'}', '$domain_user_info{'domain_gid'}', '$ftp_users' )"; 
		if ($verbose) {
                       	print "$ftp_group_sql\n";
                }
       	        if (!defined $main::db || !ref $main::db) {
               	        $main::db = DBI->connect(@main::db_connect, {PrintError => 0});
                       	if (!defined $main::db) {
                        return (-1, '');
       	                # DB: use always UTF8
               	        } elsif ($main::cfg{'DATABASE_UTF8'} eq 'yes' ) {
                       	        $ftp_group_result = $main::db->do("SET NAMES 'utf8';");
                        }
       	        }
               	if (!$dry_run) {
                       	$ftp_group_result = $main::db->do($ftp_group_sql);
		}
	}
}


sub unpack_archives {
	my $web_archive_file = "$backup_dir/$domain/$domain-www.tar.gz";
	my $mail_archive_file = "$backup_dir/$domain/$domain-mail.tar.gz";
	#my $chown_command = "/bin/chown -R $domain_user_info{'domain_uid'}.www-data $dmn_dir";
	my $chown_command = "/usr/bin/find  $dmn_dir -uid $total_config{'domain'}{'domain_uid'} -gid $total_config{'domain'}{'domain_gid'} -exec /bin/chown $domain_user_info{'domain_uid'}.$domain_user_info{'domain_gid'} {} \\;";
	my $chown_command2 = "/usr/bin/find $dmn_dir -uid $total_config{'domain'}{'domain_uid'} -exec /bin/chown $domain_user_info{'domain_uid'} {} \\;";
	my $mail_chown_command = "/bin/chown -R vmail.mail $mail_dir";
	my $cleanup_command = "/bin/rm -rf $dmn_backup_dir";
	#untar the web archive, set ownership
	if ( -f $web_archive_file) {
	print "Found $web_archive_file, extracting it\n";
		
		if (!$dry_run) {
		system($unpack_web_cmd);
		system("$chown_command");
		system("$chown_command2" );
		}
		if ($verbose) {
		print "unpack web cmd: $unpack_web_cmd\n";
		print "chown web cmd: $chown_command\n";
		print "chown web cmd: $chown_command2\n";
		}
		
	} else {
	
	print "Cannot find $web_archive_file . Exiting\n";
	exit 1;
	}
	

	#untar the mail archive, set ownership
	if ( -f $mail_archive_file) {
	print "Found $mail_archive_file, extracting it\n";
		
		if (!$dry_run) {
		system($unpack_mail_cmd);
		system($mail_chown_command);
		}
		if ($verbose) {
		print "unpack mail cmd: $unpack_mail_cmd\n";
		print "chown mail cmd: $mail_chown_command\n";
		}
		
	} else {
	
	print "Cannot find $mail_archive_file . Exiting\n";
	exit 1;
	}
	
	system ($cleanup_command);

}

#lets dump some data if we're being inquisitive 
	if ($verbose ) {	
		print " \$total_config is: $total_config \n";
		print Dumper \$total_config ;
	}


#calls the functions that grabs the ip_id, obviously 
if ($ip){
		$ip_id = get_ip_id();
	} else {
		$ip_id = get_default_ip_id();
	}

# call the remaining necessary functions. 

get_reseller();
create_domain();
create_databases();
create_database_users();
create_subdomains();
create_domain_aliases();
create_email_users();
create_web_users();
create_web_groups();
create_web_access();
create_ftp_accounts();
unpack_archives();
